com.amazonaws.services.machinelearning.model

## Class RDSDataSpec

- java.lang.Object
- - com.amazonaws.services.machinelearning.model.RDSDataSpec

All Implemented Interfaces:
  Serializable, Cloneable

    public class RDSDataSpec
    extends Object
    implements Serializable, Cloneable

The data specification of an Amazon Relational Database Service (Amazon RDS) `DataSource`.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`RDSDataSpec()`

### Method Summary

All Methods Instance Methods Concrete Methods
`RDSDataSpec` `clone()`
`boolean` `equals(Object obj)`
`RDSDatabaseCredentials` `getDatabaseCredentials()` The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.
`RDSDatabase` `getDatabaseInformation()` Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.
`String` `getDataRearrangement()` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`String` `getDataSchema()` A JSON string that represents the schema for an Amazon RDS `DataSource`.
`String` `getDataSchemaUri()` The Amazon S3 location of the `DataSchema`.
`String` `getResourceRole()` The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task.
`String` `getS3StagingLocation()` The Amazon S3 location for staging Amazon RDS data.
`List<String>` `getSecurityGroupIds()` The security group IDs to be used to access a VPC-based RDS DB instance.
`String` `getSelectSqlQuery()` The query that is used to retrieve the observation data for the `DataSource`.
`String` `getServiceRole()` The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3.
`String` `getSubnetId()` The subnet ID to be used to access a VPC-based RDS DB instance.
`int` `hashCode()`
`void` `setDatabaseCredentials(RDSDatabaseCredentials databaseCredentials)` The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.
`void` `setDatabaseInformation(RDSDatabase databaseInformation)` Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.
`void` `setDataRearrangement(String dataRearrangement)` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`void` `setDataSchema(String dataSchema)` A JSON string that represents the schema for an Amazon RDS `DataSource`.
`void` `setDataSchemaUri(String dataSchemaUri)` The Amazon S3 location of the `DataSchema`.
`void` `setResourceRole(String resourceRole)` The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task.
`void` `setS3StagingLocation(String s3StagingLocation)` The Amazon S3 location for staging Amazon RDS data.
`void` `setSecurityGroupIds(Collection<String> securityGroupIds)` The security group IDs to be used to access a VPC-based RDS DB instance.
`void` `setSelectSqlQuery(String selectSqlQuery)` The query that is used to retrieve the observation data for the `DataSource`.
`void` `setServiceRole(String serviceRole)` The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3.
`void` `setSubnetId(String subnetId)` The subnet ID to be used to access a VPC-based RDS DB instance.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`RDSDataSpec` `withDatabaseCredentials(RDSDatabaseCredentials databaseCredentials)` The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.
`RDSDataSpec` `withDatabaseInformation(RDSDatabase databaseInformation)` Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.
`RDSDataSpec` `withDataRearrangement(String dataRearrangement)` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`RDSDataSpec` `withDataSchema(String dataSchema)` A JSON string that represents the schema for an Amazon RDS `DataSource`.
`RDSDataSpec` `withDataSchemaUri(String dataSchemaUri)` The Amazon S3 location of the `DataSchema`.
`RDSDataSpec` `withResourceRole(String resourceRole)` The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task.
`RDSDataSpec` `withS3StagingLocation(String s3StagingLocation)` The Amazon S3 location for staging Amazon RDS data.
`RDSDataSpec` `withSecurityGroupIds(Collection<String> securityGroupIds)` The security group IDs to be used to access a VPC-based RDS DB instance.
`RDSDataSpec` `withSecurityGroupIds(String... securityGroupIds)` The security group IDs to be used to access a VPC-based RDS DB instance.
`RDSDataSpec` `withSelectSqlQuery(String selectSqlQuery)` The query that is used to retrieve the observation data for the `DataSource`.
`RDSDataSpec` `withServiceRole(String serviceRole)` The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3.
`RDSDataSpec` `withSubnetId(String subnetId)` The subnet ID to be used to access a VPC-based RDS DB instance.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### RDSDataSpec

    public RDSDataSpec()

### Method Detail

#### setDatabaseInformation

    public void setDatabaseInformation(RDSDatabase databaseInformation)

Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.

Parameters:
  `databaseInformation` - Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.

#### getDatabaseInformation

    public RDSDatabase getDatabaseInformation()

Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.

Returns:
  Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.

#### withDatabaseInformation

    public RDSDataSpec withDatabaseInformation(RDSDatabase databaseInformation)

Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.

Parameters:
  `databaseInformation` - Describes the `DatabaseName` and `InstanceIdentifier` of an Amazon RDS database.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setSelectSqlQuery

    public void setSelectSqlQuery(String selectSqlQuery)

The query that is used to retrieve the observation data for the `DataSource`.

Parameters:
  `selectSqlQuery` - The query that is used to retrieve the observation data for the `DataSource`.

#### getSelectSqlQuery

    public String getSelectSqlQuery()

The query that is used to retrieve the observation data for the `DataSource`.

Returns:
  The query that is used to retrieve the observation data for the `DataSource`.

#### withSelectSqlQuery

    public RDSDataSpec withSelectSqlQuery(String selectSqlQuery)

The query that is used to retrieve the observation data for the `DataSource`.

Parameters:
  `selectSqlQuery` - The query that is used to retrieve the observation data for the `DataSource`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDatabaseCredentials

    public void setDatabaseCredentials(RDSDatabaseCredentials databaseCredentials)

The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.

Parameters:
  `databaseCredentials` - The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.

#### getDatabaseCredentials

    public RDSDatabaseCredentials getDatabaseCredentials()

The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.

Returns:
  The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.

#### withDatabaseCredentials

    public RDSDataSpec withDatabaseCredentials(RDSDatabaseCredentials databaseCredentials)

The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.

Parameters:
  `databaseCredentials` - The AWS Identity and Access Management (IAM) credentials that are used connect to the Amazon RDS database.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setS3StagingLocation

    public void setS3StagingLocation(String s3StagingLocation)

The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.

Parameters:
  `s3StagingLocation` - The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.

#### getS3StagingLocation

    public String getS3StagingLocation()

The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.

Returns:
  The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.

#### withS3StagingLocation

    public RDSDataSpec withS3StagingLocation(String s3StagingLocation)

The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.

Parameters:
  `s3StagingLocation` - The Amazon S3 location for staging Amazon RDS data. The data retrieved from Amazon RDS using `SelectSqlQuery` is stored in this location.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataRearrangement

    public void setDataRearrangement(String dataRearrangement)

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Parameters:
  `dataRearrangement` - A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

#### getDataRearrangement

    public String getDataRearrangement()

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Returns:
  A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

#### withDataRearrangement

    public RDSDataSpec withDataRearrangement(String dataRearrangement)

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Parameters:
  `dataRearrangement` - A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataSchema

    public void setDataSchema(String dataSchema)

A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

A `DataSchema` is not required if you specify a `DataSchemaUri`

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Parameters:
  `dataSchema` - A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  A `DataSchema` is not required if you specify a `DataSchemaUri`

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

#### getDataSchema

    public String getDataSchema()

A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

A `DataSchema` is not required if you specify a `DataSchemaUri`

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Returns:
  A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  A `DataSchema` is not required if you specify a `DataSchemaUri`

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

#### withDataSchema

    public RDSDataSpec withDataSchema(String dataSchema)

A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

A `DataSchema` is not required if you specify a `DataSchemaUri`

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Parameters:
  `dataSchema` - A JSON string that represents the schema for an Amazon RDS `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  A `DataSchema` is not required if you specify a `DataSchemaUri`

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataSchemaUri

    public void setDataSchemaUri(String dataSchemaUri)

The Amazon S3 location of the `DataSchema`.

Parameters:
  `dataSchemaUri` - The Amazon S3 location of the `DataSchema`.

#### getDataSchemaUri

    public String getDataSchemaUri()

The Amazon S3 location of the `DataSchema`.

Returns:
  The Amazon S3 location of the `DataSchema`.

#### withDataSchemaUri

    public RDSDataSpec withDataSchemaUri(String dataSchemaUri)

The Amazon S3 location of the `DataSchema`.

Parameters:
  `dataSchemaUri` - The Amazon S3 location of the `DataSchema`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setResourceRole

    public void setResourceRole(String resourceRole)

The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.

Parameters:
  `resourceRole` - The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.

#### getResourceRole

    public String getResourceRole()

The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.

Returns:
  The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.

#### withResourceRole

    public RDSDataSpec withResourceRole(String resourceRole)

The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.

Parameters:
  `resourceRole` - The role (DataPipelineDefaultResourceRole) assumed by an Amazon Elastic Compute Cloud (Amazon EC2) instance to carry out the copy operation from Amazon RDS to an Amazon S3 task. For more information, see Role templates for data pipelines.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setServiceRole

    public void setServiceRole(String serviceRole)

The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.

Parameters:
  `serviceRole` - The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.

#### getServiceRole

    public String getServiceRole()

The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.

Returns:
  The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.

#### withServiceRole

    public RDSDataSpec withServiceRole(String serviceRole)

The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.

Parameters:
  `serviceRole` - The role (DataPipelineDefaultRole) assumed by AWS Data Pipeline service to monitor the progress of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for data pipelines.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setSubnetId

    public void setSubnetId(String subnetId)

The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.

Parameters:
  `subnetId` - The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.

#### getSubnetId

    public String getSubnetId()

The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.

Returns:
  The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.

#### withSubnetId

    public RDSDataSpec withSubnetId(String subnetId)

The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.

Parameters:
  `subnetId` - The subnet ID to be used to access a VPC-based RDS DB instance. This attribute is used by Data Pipeline to carry out the copy task from Amazon RDS to Amazon S3.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### getSecurityGroupIds

    public List<String> getSecurityGroupIds()

The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

Returns:
  The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

#### setSecurityGroupIds

    public void setSecurityGroupIds(Collection<String> securityGroupIds)

The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

Parameters:
  `securityGroupIds` - The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

#### withSecurityGroupIds

    public RDSDataSpec withSecurityGroupIds(String... securityGroupIds)

The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

NOTE: This method appends the values to the existing list (if any). Use `setSecurityGroupIds(java.util.Collection)` or `withSecurityGroupIds(java.util.Collection)` if you want to override the existing values.

Parameters:
  `securityGroupIds` - The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### withSecurityGroupIds

    public RDSDataSpec withSecurityGroupIds(Collection<String> securityGroupIds)

The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.

Parameters:
  `securityGroupIds` - The security group IDs to be used to access a VPC-based RDS DB instance. Ensure that there are appropriate ingress rules set up to allow access to the RDS DB instance. This attribute is used by Data Pipeline to carry out the copy operation from Amazon RDS to an Amazon S3 task.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public RDSDataSpec clone()

Overrides:
  `clone` in class `Object`